// Copyright (c) 2013  Pavel Rychly, Milos Jakubicek

#include <finlib/revidx.hh>
#include <iostream>
#include <cstdlib>

using namespace std;

int main (int argc, char **argv)
{
    if (argc != 3) {
        cerr << "usage: dumpdrev REV_PATH ID\n";
        return 1;
    }
    int id = atoi(argv[2]);
    try {
        file_delta_revidx rev (argv[1]);
        NumOfPos cnt = rev.count (id);
        FastStream *fs = rev.id2poss (id);
        while (cnt--)
            cout << fs->next() << '\n';
    } catch (exception &e) {
        cerr << e.what() << endl;
        return 1;
    }
    return 0;
}

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
